<?php

use Drp\NativeEventApp\Migrations\TableMigration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreatePagesTable extends TableMigration
{
    public function tableName(): string
    {
        return 'pages';
    }

    public function up(): void
    {
        Schema::create($this->getTableNameWithPrefix(), static function (Blueprint $table): void {
            $table->increments('id');
            $table->unsignedInteger('event_id');
            $table->string('title');
            $table->text('modules')->nullable();
            $table->timestamp('enabled_at')->nullable();
            $table->timestamp('enabled_until')->nullable();
            $table->integer('order')->nullable();
            $table->timestamps();
        });
    }

    public function down(): void
    {
        Schema::dropIfExists($this->getTableNameWithPrefix());
    }
}
