<?php

use Drp\NativeEventApp\Database\TableName;
use Drp\NativeEventApp\Migrations\TableMigration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSegmentsTable extends TableMigration
{
    public function tableName(): string
    {
        return 'segments';
    }

    public function up(): void
    {
        Schema::create($this->getTableNameWithPrefix(), function (Blueprint $table): void {
            $table->bigIncrements('id');
            $table->string('name')->nullable();
            $table->timestamps();
        });

        Schema::create(TableName::make('segments_registrations'), function (Blueprint $table): void {
            $table->bigIncrements('id');
            $table->integer('segment_id')->unsigned();
            $table->integer('registration_id')->unsigned();
            $table->timestamps();
        });

        Schema::create(TableName::make('segments_pages'), function (Blueprint $table): void {
            $table->bigIncrements('id');
            $table->integer('segment_id')->unsigned();
            $table->integer('page_id')->unsigned();
            $table->timestamps();
        });

        Schema::create(TableName::make('segments_navigatable_items'), function (Blueprint $table): void {
            $table->bigIncrements('id');
            $table->integer('segment_id')->unsigned();
            $table->integer('navigatable_item_id')->unsigned();
            $table->timestamps();
        });
    }

    public function down(): void
    {
        Schema::dropIfExists($this->getTableNameWithPrefix());
    }
}
