<?php

namespace Drp\NativeEventApp;

use Illuminate\Support\Str as IlluminateStr;

class ArrayKeys
{
    /**
     * Convert all the keys into snake case.
     */
    public static function snake(array $array): array
    {
        return self::convert(self::camelCase($array), [IlluminateStr::class, 'snake']);
    }

    /**
     * Convert all the keys into camel case.
     */
    public static function camelCase(array $array): array
    {
        return self::convert($array, [IlluminateStr::class, 'camel']);
    }

    /**
     * Convert all the keys using the given callback.
     */
    public static function convert(array $array, callable $callback): array
    {
        $keys = array_keys($array);
        $values = array_values($array);

        $newKeys = array_map(
            static function ($key) use ($callback) {
                return $callback($key);
            },
            $keys
        );

        return array_combine($newKeys, $values);
    }
}
