<?php

namespace Drp\NativeEventApp\Console\Commands;

use Drp\NativeEventApp\Models\Notification;
use Drp\NativeEventApp\Notifications\Events\SendNotification;
use Illuminate\Console\Command;

class SendScheduledNotifications extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'notifications:send';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Sends all scheduled notifications that have not already been sent';

    public function handle(): void
    {
        Notification::toBeSent()->each(static function (Notification $notification): void {
            event(new SendNotification($notification));
        });
    }
}
