<?php

namespace Drp\NativeEventApp\Exceptions;

use GraphQL\Error\ClientAware;

class UserNotFound extends \Exception implements ClientAware
{
    public static function fromIdentifier(string $userIdentifier): self
    {
        return new self("User not found with identifier $userIdentifier");
    }

    public function isClientSafe(): bool
    {
        return true;
    }

    public function getCategory(): string
    {
        return 'auth';
    }
}
