<?php

namespace Drp\NativeEventApp\GraphQL\Mutations;

use Drp\NativeEventApp\Models\Device;
use GraphQL\Type\Definition\ResolveInfo;
use Illuminate\Support\Facades\DB;
use Nuwave\Lighthouse\Support\Contracts\GraphQLContext;

class Logout
{
    //phpcs:ignore
    public function __invoke($rootValue, array $args, ?GraphQLContext $context = null, ResolveInfo $resolveInfo): array
    {
        $token = $context->token();
        DB::table('oauth_refresh_tokens')->where('access_token_id', $token->id)->delete();
        $token->delete();
        optional(Device::getByToken($token))->delete();

        return [
            'status' => 'TOKEN_REVOKED',
            'message' => 'Your session has been terminated',
        ];
    }
}
