<?php

namespace Drp\NativeEventApp\Models;

use Drp\NativeEventApp\Models\Concerns\PrefixedTable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class FailedNotification extends Model
{
    use PrefixedTable;

    /** @var string */
    protected $table = 'failed_notifications';

    /** @var array */
    protected $fillable = [
        'notification_id',
        'device_id',
        'error',
    ];

    public function device(): BelongsTo
    {
        return $this->belongsTo(Device::class, 'device_id', 'id');
    }

    public function notification(): BelongsTo
    {
        return $this->belongsTo(Notification::class, 'notification_id', 'id');
    }
}
