<?php

namespace Drp\NativeEventApp\Modules\Types;

use Drp\NativeEventApp\Modules\Containerable;
use Drp\NativeEventApp\Modules\Module;
use Drp\NativeEventApp\Modules\Modules;

abstract class Container extends Module implements Containerable
{
    /** @var Modules */
    public $children;

    public function __construct()
    {
        $this->children = new Modules;
    }

    /**
     * @param \Drp\NativeEventApp\Modules\Modules|array $children
     */
    public function children($children): Containerable
    {
        if (is_array($children)) {
            $children = Modules::make($children);
        }

        $this->children = $children;

        return $this;
    }

    public function hasChildren(): bool
    {
        return $this->getChildren()->isNotEmpty();
    }

    public function getChildren(): Modules
    {
        return $this->children ?? new Modules;
    }
}
