<?php

namespace Drp\NativeEventApp\Test\Support;

use Drp\NativeEventApp\Auth\AuthInfoFinder;
use Drp\NativeEventApp\Models\Event;
use Drp\NativeEventApp\Models\Registration;
use Drp\NativeEventApp\Test\Support\Fakes\Delegate;

trait InteractsWithEvents
{
    public function registerFakeEvent(?Event $event = null): array
    {
        $this->event = $event ?? factory(Event::class)->create();
        $user = (new Delegate)->setEvents(collect([$this->event]));
        $this->actingAs($user, 'api');

        AuthInfoFinder::setAuthResolver(static function ($userIdentifier) use ($user) { // phpcs:ignore
            return $user;
        });

        AuthInfoFinder::setCurrentUserResolver(static function () use ($user): Delegate {
            return $user;
        });

        return [$user, $this->event];
    }

    public function registerFakeEventWithRegistration(array $registrationAttributes = [], ?Event $event = null): array
    {
        [$user, $event] = $this->registerFakeEvent($event);

        $this->registration = factory(Registration::class)->create(array_merge([
            'eventId' => $event->id,
            'authId' => $user->getAuthIdentifier(),
        ], $registrationAttributes));

        return [$user, $event, $this->registration];
    }
}
