<?php

namespace Drp\NativeEventApp\Test\Unit\Modules;

use Drp\NativeEventApp\Facades\ModulesUnSerializer;
use Drp\NativeEventApp\Modules\Types\Image;
use Drp\NativeEventApp\Test\TestCase;

class ImageTest extends TestCase
{
    /** @test */
    public function is_serializable(): void
    {
        $src = 'http://www.example.com/image.png';
        $image = Image::make($src);

        $serializedModule = json_encode([$image]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(Image::class, $module);
        $this->assertEquals($src, $module->src);
    }

    /** @test */
    public function it_can_set_resize_mode(): void
    {
        $src = 'http://www.example.com/image.png';
        $image = Image::make($src);

        $image->resizeMode('500x500');

        $this->assertEquals('500x500', $image->resizeMode);
    }
}
