<?php

namespace Drp\NativeEventApp\Test\Unit\Modules\Types\Form;

use Drp\NativeEventApp\Facades\ModulesUnSerializer;
use Drp\NativeEventApp\Modules\Types\Form\RadioGroup;
use Drp\NativeEventApp\Modules\Types\Form\Select;
use Drp\NativeEventApp\Test\TestCase;

class RadioGroupTest extends TestCase
{
    /** @test */
    public function is_serializable(): void
    {
        $radioGroup = RadioGroup::make('radio-group')->options([
            'Label One' => '1',
            'Label Two' => '2',
        ]);
        $options = $radioGroup->options;

        $serializedModule = json_encode([$radioGroup]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(RadioGroup::class, $module);
        $this->assertEquals($options, $module->options);
    }
}
