<?php

namespace Drp\NativeEventApp\Test\Unit\Modules\Types\Form;

use Drp\NativeEventApp\Facades\ModulesUnSerializer;
use Drp\NativeEventApp\Modules\Types\Form\TextArea;
use Drp\NativeEventApp\Modules\Types\Form\TextInput;
use Drp\NativeEventApp\Test\TestCase;

class TextAreaTest extends TestCase
{
    /** @test */
    public function is_serializable(): void
    {
        $textArea = TextArea::make('textarea');

        $serializedModule = json_encode([$textArea]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(TextArea::class, $module);
        $this->assertFalse($module->required);
    }

    /** @test */
    public function it_can_set_the_required_flag(): void
    {
        $textArea = TextArea::make('required-input')->required();

        $serializedModule = json_encode([$textArea]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(TextArea::class, $module);
        $this->assertTrue($module->required);
    }
}
